/* definitions for standard programs */



#include <stdlib.h>

#include <conio.h>

#include <stdio.h>

#include <errno.h>

#include <string.h>

#include <time.h>

#include <ctype.h>

#include <niterror.h>



time_t isMEST(time_t *t);



/* localtime for MET with daylight saving support */



struct tm *Localtime(time_t *t)

{

struct tm *tnow;

time_t dst;

tnow=localtime(t);

/* if (CheckNetWareVersion(4,0,0,1,1)!= VERSION_NUMBER_TOO_LOW)

  return tnow; */

dst=isMEST(t);

*t+=dst;

return localtime(t);

}



/* return 3600 if daylight saving is active in MET */



time_t isMEST(time_t *t)

{

int days[12]={0,31,59,90,120,151,181,212,243,273,304,334};

struct tm *tnow;

time_t T;

int add1=0,d0,d1,d2,h0,h1,h2;



if (t)

  tnow=localtime(t);

else

  {

  time(&T);

  tnow=localtime(&T);

  }



add1=((tnow->tm_year) % 4)==0;

d0=(((tnow->tm_year)*5)/4)%7;



d1=days[3]+add1-((days[3]+d0)%7)-1;

d2=days[9]+add1-((days[9]+d0)%7)-1;



h1=d1*24+2; h2=d2*24+2;

h0=tnow->tm_yday*24+tnow->tm_hour;

if (h0>=h1 && h0<h2)

  return 3600;

else

  return 0;

}



void main(int argc, char *argv[])

{

time_t t;

BYTE st[8];



struct tm *tnow;

do {

   time(&t);

   tnow=localtime(&t);

   gotoxy(0,0);

   printf("1336\nlocal:  %02d.%02d\n",tnow->tm_hour,tnow->tm_min);

   GetFileServerDateAndTime(st);

   printf("server: %02d.%02d\n",st[3],st[4]);

   time(&t);

   tnow=gmtime(&t);

   printf("GMT:    %02d.%02d\n",tnow->tm_hour,tnow->tm_min);

   tnow=Localtime(&t);

   printf("Local:   %02d.%02d\n",tnow->tm_hour,tnow->tm_min);

   printf("%s\n",isMEST(NULL) ? "MEST" : "MET ");

   delay(1000);

   } while (!kbhit());

}

