/* definitions for standard programs */



#include <stdlib.h>

#include <conio.h>

#include <stdio.h>

#include <errno.h>

#include <string.h>

#include <ctype.h>



#include <library.h>

#include <process.h>

#include <nwenvrn.h>

#include <advanced.h>

#include "NWSERVST.H"



LONG libHandle=0;

char myName[48];

int  numConn=0,run=0,theConsole=0,patchCall=0,callCount=0,verbose;



LONG myCommand(LONG screenID,BYTE *cmdline);



struct commandParserStructure

  myParserStruct={

    0,

    myCommand,

    0 };





int clientCleanupFunction(void *p)

{

return 0;

}



/* cleanup function:

   deregisters library */



void cleanup(void)

{

if (libHandle)

   DeregisterLibrary(libHandle);

}



/* remove CC Handler */



void removeCCHandler(void)

{

UnRegisterConsoleCommand(&myParserStruct);

}



/* my console command routine */



LONG myCommand(LONG screenID,BYTE *cmdline)

{

char *cmd;

int i;

if (screenID==theConsole)

  {

  if (!strnicmp(cmdline,"EA ",3))

    {

    cmd=strtok(cmdline+3," ");

    if (!strcmp(cmd,"exit"))

      {

      run=0;

      return 0;

      }

    if (!stricmp(cmd,"off"))

      {

      patchCall=0;

      return 0;

      }

    if (!stricmp(cmd,"on"))

      {

      patchCall=1;

      return 0;

      }

    if (!stricmp(cmd,"verbose"))

      {

      verbose=1;

      return 0;

      }

    if (!stricmp(cmd,"quiet"))

      {

      verbose=0;

      return 0;

      }

    if (!stricmp(cmd,"stat"))

      {

      ConsolePrintf("EA %s (%d connections)\n\r",patchCall ? "ON" : "OFF",numConn);

      return 0;

      }

    if (i=atoi(cmd))

      {

      numConn=i;

      return 0;

      }

    return 1;

    }

  return 1;

  }

else

  return 1;

}



int NWNCPsend (BYTE   functionCode,char    *sendPacket,WORD   sendLen,

               char   *replyBuf,WORD   replyLen)



{

int cC,i;

GetOSVersionInfoStructure *OSI;



// ConsolePrintf("NWNCPSend: %d\n\r",functionCode);

cC=NWNCPSend (functionCode,sendPacket,sendLen,replyBuf,replyLen);

if (functionCode != 123)

  return cC;

if (patchCall)

  {

  OSI=(GetOSVersionInfoStructure *) replyBuf;

  OSI->maxNumOfUsers=numConn;

  }

// ConsolePrintf("%d\n",OSI->maxNumOfUsers);

/* for (i=0;i< replyLen;i++)

  ConsolePrintf("%3d ",replyBuf[i]); */

return cC;

}



int getServerInformation(int structSize,FILE_SERV_INFO *serverInfo)

{

int cC;



cC=GetServerInformation(structSize,serverInfo);

if (patchCall)

  {

  if (verbose)

    ConsolePrintf("Server %s: %d\n",serverInfo->serverName,

      serverInfo->maxConnectionsSupported);

  if (!strcmp(serverInfo->serverName,myName))

    serverInfo->maxConnectionsSupported=numConn+100;

  else

    {

    serverInfo->maxConnectionsSupported=min(

      numConn,serverInfo->maxConnectionsSupported);

/*    if (serverInfo->netwareVersion==4)

      {

      serverInfo->netwareVersion=3;

      serverInfo->netwareSubVersion=12;

      } */

    }

  }

return cC;

}



void main(int argc,char *argv[])

{

int myID;

LONG consoleCommandTag;

unsigned myNLMHandle;

FILE_SERV_INFO serverInfo;

myID=GetNLMID();

myNLMHandle=GetNLMHandle();

*myName=0;

GetFileServerName(0,myName);

if (!GetServerInformation(sizeof(FILE_SERV_INFO),&serverInfo))

    {

    if (argc>1)

      numConn=max(1,atoi(argv[1]));

    else

      numConn=max(numConn,serverInfo.maxConnectionsSupported-100);

    ConsolePrintf("%d\n",serverInfo.maxConnectionsSupported);

    }



theConsole=__GetScreenID(CreateScreen("System Console",0));



if ((libHandle=RegisterLibrary(clientCleanupFunction))!=-1)

  {

  ConsolePrintf("Library registered\n");

  if (consoleCommandTag=AllocateResourceTag(myNLMHandle,

    "EA library console command",ConsoleCommandSignature))

    {

    myParserStruct.RTag=(struct ResourceTagStructure *)consoleCommandTag;

    RegisterConsoleCommand(&myParserStruct);

    atexit(removeCCHandler);

    run=1;

    patchCall=1;

    }

  AtUnload(cleanup);

  do {

     delay(2000);

     } while(run);

  cleanup();

  }

}

