/* standard file for programs using NetWare calls */



#include <stdio.h>

#include <nwbindry.h>

#include <nwipxspx.h>

#include <nwtypes.h>

#include <ctype.h>

#include <time.h>



#define TARGET_SOCKET 0x8888 /* where to send the packet */



int sendPacket(long dest)

{

int     i;

unsigned long    l;

InternetAddress srcAdd,destAdd;

IPX_ECB     sendECB;

IPX_HEADER sendHeader;

char      data[100];

time_t    theTime;

theTime=time(NULL);



*(WORD *)srcAdd.socket=0;

if (IpxOpenSocket(&srcAdd.socket))

  return(3);

*(long *)&destAdd=LongSwap(dest);        /* destination network */

memset(destAdd.node,0xff,6);             /* destination node */

destAdd.socket = TARGET_SOCKET;          /* destination socket */



/* prepare send ECB and data portion */



sprintf(data,"Current time : %s",ctime(&theTime));

if (IpxGetLocalTarget((BYTE *)&destAdd,&sendECB,&l))

  {

  IpxCloseSocket(srcAdd.socket);

  return(1);

  }

sendECB.queueHead = NULL;

sendECB.next = NULL;

sendECB.prev = NULL;

sendECB.socket = * (int *)srcAdd.socket; /* own socket */

sendECB.fragCount = 2;

sendECB.fragList[0].fragAddress=&sendHeader;

sendECB.fragList[0].fragSize=sizeof(sendHeader);

sendECB.fragList[1].fragAddress=data;

sendECB.fragList[1].fragSize=sizeof(data);

sendHeader.packetType = 0;

memcpy(&sendHeader.destNet,&destAdd,sizeof(destAdd));



if (IpxSend(0,&sendECB))

  i=4;

else

  i=0;

IpxCloseSocket(srcAdd.socket);

return(i);

}



int main(int argc, char *argv[])

{

long destinationNetwork;

int  i;

if (argc==1)

  return(2);

if (argc>2)

  i=atoi(argv[2]);

destinationNetwork=strtoul(argv[1],NULL,16);

do {

   sendPacket(destinationNetwork);

   delay(1000);

   i--;

   } while (i>0);

}

