/* definitions for standard programs */

/* NDS Hook function */



#include <stdlib.h>

#include <conio.h>

#include <stdio.h>

#include <errno.h>

#include <string.h>

#include <ctype.h>

#include <conio.h>

#include <time.h>

#include <process.h>

#include <advanced.h>

#include <nwmisc.h>

#include <nwconn.h>

#include <nwsemaph.h>



long eventHandleChangeValue=NULL;   // handle for RegisterForEvent

LONG semaV=NULL;

int run=1;



struct EventDSObject theDSObjV;



char *Word2ByteStr(WORD *ws)

{

static char s[257];

int i;



for (i=0;i<257;i++)

  if ((s[i]=ws[i])==0) break;

return s;

}



void cleanup()

{

if (eventHandleChangeValue)

  UnregisterForEvent(eventHandleChangeValue);

run=0;

SignalLocalSemaphore(semaV);

delay(1000);

if (semaV)

  CloseLocalSemaphore(semaV);

}



void reportValue(void *p)

{

struct EventBinderyObject *bObj;

struct EventDSObject *dsObj;



while (1) {

WaitOnLocalSemaphore(semaV);

if (!run)

  return;



bObj=(struct EventBinderyObject *)&theDSObjV;

dsObj=(struct EventDSObject *)&theDSObjV;



cprintf("Value: ");

if (bObj->EventObjectType==EventBinderySignature) // Bindery object

  {

  cprintf("Bindery object %08lX (type=%04X)\n",bObj->ObjectID,bObj->ObjectType);

  }

else // DS object

  cprintf("NDS object '%s', ('%s'), %08lX (event type=%04X).\n",

  Word2ByteStr(dsObj->objName),Word2ByteStr(dsObj->otherName),LongSwap(dsObj->objID),dsObj->EventType);

}

}



void eventHandlerChange(LONG p)

{

memcpy(&theDSObjV,p,sizeof(theDSObjV));

SignalLocalSemaphore(semaV);

}



void main(int argc, char *argv[])

{

eventHandleChangeValue=RegisterForEvent(EVENT_VALUE_ADD,eventHandlerChange,NULL);



atexit ( cleanup );



if (eventHandleChangeValue==NULL)

  {

  cleanup();

  return;

  }



semaV=OpenLocalSemaphore(0l);

BeginThread(reportValue,NULL,4096,NULL);



ExitThread(TSR_THREAD,0);

}

