/* definitions for standard programs */



#include <stdio.h>

#include <ctype.h>

#include <conio.h>

#include <advanced.h>

#include <process.h>

#include <time.h>

#include <nwsnut.h>

#include <string.h>

#include <malloc.h>



/******  Global variables in this module *******/



NUTInfo *handle;

LONG    NLMHandle;

LONG    allocTag, infoPortalNumber;

int     CLIBScreenID;

PCB     *myPortal;



BYTE   *msgs[64]={ "eins", "zwei", "drei","vier","ende" };

#define MSG_FORM 2



void myunload(void)

{

if (handle)

  NWSRestoreNut(handle);

if (CLIBScreenID)

  DestroyScreen(CLIBScreenID);

}



int ListAction (LONG keyPressed, LIST **elementSelected, LONG *itemNumber, void *listParameter)

{

static LONG l=42;

static char tmp[16];



elementSelected = elementSelected;

listParameter = listParameter;



if (keyPressed == M_ESCAPE)

  return 1;



NWSPushList(handle);

NWSInitForm(handle);

sprintf(tmp,"%08lX",time(NULL));

NWSDisplayTextInPortal(0,0,tmp,VNORMAL,myPortal);



NWSAppendCommentField (1, 1, "Integer Field:", handle);

NWSAppendIntegerField (1, 15, NORMAL_FIELD, &l, 0,1000,NULL,handle);



NWSEditPortalForm (MSG_FORM, 11, 40, 8, 40, F_NOVERIFY, F_NO_HELP, 3, handle);

NWSDestroyForm (handle);

NWSPopList(handle);

return -1;

}



void main(void) //int argc, char *argv[])

{

LONG    ccode;

PCB     *ipPtr;

        WORD screenHeight, screenWidth;



NLMHandle = GetNLMHandle();



CLIBScreenID = CreateScreen("NWSNUT Demo Screen", AUTO_DESTROY_SCREEN);

if (!CLIBScreenID)

  return;



allocTag = AllocateResourceTag(NLMHandle, "MYNUT Alloc Tag",AllocSignature);

if (!allocTag)

  {

  DestroyScreen(CLIBScreenID);

  return;

  }



if (NWSInitializeNut(0,0,NORMAL_HEADER,NUT_REVISION_LEVEL,

    msgs, 0, CLIBScreenID, allocTag, &handle))

        {

        DestroyScreen(CLIBScreenID);

        return;

        }

AtUnload(myunload);

DisplayScreen(CLIBScreenID);

GetSizeOfScreen (&screenHeight, &screenWidth);



infoPortalNumber = NWSCreatePortal(15,0,9,screenWidth,

                        screenHeight,screenWidth-2, SAVE,

                        (BYTE *) 0, 0L, SINGLE, 0, CURSOR_OFF, VIRTUAL, handle);



if (infoPortalNumber > MAXPORTALS)

  {

  printf ("Unable to create information portal\n");

  NWSRestoreNut(handle);

  DestroyScreen(CLIBScreenID);

  return;

  }



NWSGetPCB (&ipPtr, infoPortalNumber, handle);

myPortal=ipPtr;



NWSInitList (handle, free);



NWSAppendToList ("Item 1|Ein ",(void *) 0, handle);

NWSAppendToList ("Item 2|Aus ",(void *) 0, handle);



NWSClearPortal(myPortal);

NWSDisplayTextInPortal(0,0,"Dies\nist\nein\n\nTest.",0,myPortal);

NWSUpdatePortal(myPortal);

NWSList (1, 10, 40, 2, strlen(msgs[1]),

                M_ESCAPE | M_SELECT, NULL, handle, NULL, ListAction, 0);



NWSDestroyList (handle);



NWSDestroyPortal (infoPortalNumber, handle);

NWSRestoreNut(handle);

DestroyScreen(CLIBScreenID);

}

