/* definitions for standard programs */



#include <stdlib.h>

#include <conio.h>

#include <stdio.h>

#include <errno.h>

#include <string.h>

#include <ctype.h>

#include <conio.h>

#include <time.h>

#include <process.h>

#include <advanced.h>



#define DELAY_TIME   200            /* delay time for clock update */

#define ONE_SECOND   1000

#define ONE_MINUTE   60*ONE_SECOND

#define FIFE_SECONDS 5*ONE_SECOND



#define MAXBALLS 50

#define MAX_X    79

#define MAX_Y    25



#define random(x) (rand()%(x))



extern int MaximumNumberOfPollingLoops,NumberOfPollingLoops;

int saving=0,run=0,saveCount=0;

long eventHandle=NULL;   // handle for RegisterForEvent

char *myname;



struct balltype

  {

    int x;

    int y;

    int sx;

    int sy;

  };



int ball_save(int balls, int speed, int DELAY)

{

int i,j;

WORD ball=0x0b2a, noball=0x0b20;

struct balltype b[MAXBALLS];



if ((balls>MAXBALLS)||(balls<1)) return(42);



for (i=0; i<balls; i++)

  {

    b[i].x=random(MAX_X);      /* Zufllige Position */

    b[i].y=random(MAX_Y);

    do

      {

       b[i].sx=random(speed*2+1)-speed;    /* Zufllige Geschwindigkeit */

       b[i].sy=random(speed*2+1)-speed;

      }

    while ((b[i].sy==0)&&(b[i].sx==0)); /* Speed nicht 0 */

  }





// clrscr();



while (saving)

  {

    for (i=0; i<balls; i++)

      {

        CopyToScreenMemory(1,1,&noball,b[i].x,b[i].y); /* Alten Ball lschen */



        b[i].x=b[i].x+b[i].sx;                     /* Neue Position berechnen */

        b[i].y=b[i].y+b[i].sy;



        if (b[i].x<0)                              /* linke Wand ? */

          {

            b[i].sx=-b[i].sx;

            b[i].x=0;

          }

        if (b[i].x>=MAX_X)                         /* rechte Wand ? */

          {

            b[i].sx=-b[i].sx;

            b[i].x=MAX_X-1;

          }

        if (b[i].y<0)                              /* untere Wand ? */

          {

            b[i].sy=-b[i].sy;

            b[i].y=0;

          }

        if (b[i].y>=MAX_Y)                         /* obere Wand ? */

          {

            b[i].sy=-b[i].sy;

            b[i].y=MAX_Y-1;

          }

        for (j=0; j<i; j++)                        /* anderer Ball ? */

          if ((b[i].x==b[j].x)&&(b[i].y==b[j].y))

            do

              {

                b[i].sx=random(speed*2+1)-speed;

                b[i].sy=random(speed*2+1)-speed;

              }

            while ((b[i].sy==0)&&(b[i].sx==0));



        CopyToScreenMemory(1,1,&ball,b[i].x,b[i].y);

      }

    delay (DELAY);

  }

}



void keyPressEventHandler(LONG p)

{

saving=saveCount=0;

}



/* screen saving routine */



void doSave(void)

{

int n=0,i,myScreen,l,x,y;

WORD cols,rows;

char *p="PH Screen Saver";



myScreen=CreateScreen("PH Screen Saver Screen",AUTO_DESTROY_SCREEN | POP_UP_SCREEN);

if (myScreen==NULL)

  return;

SetCurrentScreen(myScreen);

HideInputCursor();

saving=1;

ball_save(50,1,DELAY_TIME);

if (myScreen)

  DropPopUpScreen(myScreen);

}



void cleanup()

{

if (eventHandle)

  UnregisterForEvent(eventHandle);

}





void usage()

   {

      ConsolePrintf ( "Usage %s [timeout in sec]\n", myname );

      ConsolePrintf ( " Default timeout = 60 s.\n");

      exit ( 0 );

   }





main ( int argc, char *argv [] )

{

   int   timeout=ONE_MINUTE,saveLimit;



   myname=argv[0];



   if ( argc>1 )

     {

     if (argv[1][0]=='?')

       usage();

     timeout=atoi(argv[1]);

     }



   saveLimit=(timeout*ONE_SECOND)/DELAY_TIME;



   eventHandle=RegisterForEvent(EVENT_KEY_WAS_PRESSED,keyPressEventHandler,NULL);

   if (eventHandle==NULL)

     return;

   AtUnload ( cleanup );

   run=1;

   do

   {

      delay(DELAY_TIME);

      saveCount++;

      if (saveCount>saveLimit)

        {

        doSave();

        saveCount=0;

        }

   } while ( run );

}

