/* standard file for programs using NetWare calls */



#include <stdio.h>

#include <nwbindry.h>

#include <string.h>

#include <ctype.h>



#define WRONG_ARGC "Wrong number of arguments\n"

#define WRONG_OPT "Wrong option\n"



char    progName[16];



void usage(char *msg)

{

printf("%sUsage: %s -{c[reate]|d[elete]} OName OType [ OSecurity ]\n",msg,progName);

printf("       -c  = create object, -d delete object\n");

printf(" OName     = name of object to be processed\n");

printf(" OType     = type of object to be processed in hex\n");

printf(" OSecurity = object security in hex, only needed for create\n");

exit(0);

}



void getprogname(char *argv0)

{

char *p1;

if ((p1=strrchr(argv0,'.'))!=NULL)

  *p1=0;

if ((p1=strrchr(argv0,'\\'))!=NULL)

  strncpy(progName,p1+1,sizeof(progName));

else

  strncpy(progName,argv0,sizeof(progName));

}

void main(int argc, char *argv[])

{

char *oName;

BYTE oSecurity;

WORD oType;

int  cC;



getprogname(argv[0]);



if (argv[1][0]!='-')

  usage("Missing option!\n");



if (argc<4)

  usage(WRONG_ARGC);



oName=strupr(argv[2]);

oType=(WORD)strtol(argv[3],NULL,16);



switch (toupper(argv[1][1])) {

  case 'C' : if (argc < 5)

    usage(WRONG_ARGC);

  else

    {

    oSecurity=(BYTE)strtol(argv[4],NULL,16);

    printf("Create: %s %X %X",oName,oType,oSecurity);

    cC=CreateBinderyObject(oName,oType,BF_STATIC,oSecurity);

    }

  break;



  case 'D' : if (argc < 4)

    usage(WRONG_ARGC);

  else

    {

    printf("Delete: %s %X %s",oName,oType);

    cC=DeleteBinderyObject(oName,oType);

    }

  break;



  default :

    usage(WRONG_OPT);

  }

if (cC)

  printf(", CC=%02X\n",cC);

}

