/* standard file for programs using NetWare calls */



#include <stdio.h>

#include <nwbindry.h>

#include <nwipxspx.h>

#include <nwtypes.h>

#include <ctype.h>



#define RESET_SOCKET 0x8282



int sendResetPacket(long dest)

{

int     i;

unsigned long    l;

InternetAddress sendAdd,receiveAdd;

IPX_ECB     sendECB;

IPX_HEADER sendHeader;

char      data[16];



*(WORD *)sendAdd.socket=0;

if (IpxOpenSocket(&sendAdd.socket))

  return(3);

memset(&receiveAdd,0xff,12);

*(long *)&receiveAdd=LongSwap(dest);

*(int *)receiveAdd.socket = RESET_SOCKET;



/* prepare send ECB and data portion */



sprintf(data,"R:%08lX\n$",dest);

for (i=0,data[15]=0;i<15;data[15]+=data[i++]);

data[15]^=0xff;

if (IpxGetLocalTarget((BYTE *)&receiveAdd,&sendECB,&l))

  return(1);

for (i=0;i<6;printf("%02X",sendECB.immediateAddress[i++]));

printf("\n");

sendECB.queueHead = 0l;        /* no ESR */

sendECB.socket = * (int *)sendAdd.socket; /* own socket */

sendECB.fragCount = 2;

sendECB.fragList[0].fragAddress=&sendHeader;

sendECB.fragList[0].fragSize=sizeof(sendHeader);

sendECB.fragList[1].fragAddress=data;

sendECB.fragList[1].fragSize=sizeof(data);

sendHeader.packetType = 0;

memcpy(&sendHeader.destNet,&receiveAdd,sizeof(receiveAdd));



if (IpxSend(0,&sendECB))

  i=4;

else

  i=0;

IpxCloseSocket(sendAdd.socket);

return(i);

}



int main(int argc, char *argv[])

{

long destinationNetwork;

if (argc==1)

  return(2);

if (GetBinderyObjectID("MAILQUEUE",OT_PRINT_QUEUE,&destinationNetwork))

  return(1);

destinationNetwork=strtoul(argv[1],NULL,16);

printf("%x\n",sendResetPacket(destinationNetwork));

}

