/* definitions for standard programs */



#include <stdlib.h>

#include <conio.h>

#include <stdio.h>

#include <errno.h>

#include <string.h>

#include <ctype.h>

#include <time.h>

#include <nwtypes.h>

#include <process.h>

#include <nwenvrn.h>

#include <nwbindry.h>

#include <nwconn.h>

#include <nwcntask.h>



/* Synchronize server time with time on a given server where the NLM logs in

   as GUEST at given intervals */



#define ONE_MINUTE 60000

#define DEFAULT 30



void main(int argc, char *argv[])

{

char *timeServer,loginStr[128];

int  updateInterval=DEFAULT;   /* default 30 minutes */

int  cC;

time_t t;

WORD hostID;

BYTE serverTime[7];



if (argc==1)

  {

  printf("Usage %s server [updateInterval]\n",argv[0]);

  printf("  server :        name of file server which to synchronize time with\n");

  printf("  updateInterval: interval in minutes, default are 30 minutes\n");

  return;

  }

timeServer=strupr(argv[1]);

if (argc>2)

  updateInterval=atoi(argv[2]);

if (!updateInterval)

  updateInterval=DEFAULT;

sprintf(loginStr,"%s/GUEST",timeServer);

do {

   if (cC=LoginToFileServer(loginStr,OT_USER,"\0"))

     {

     t=time(NULL);

     printf("LoginToFileServer returned error %x, %s",cC,ctime(&t));

     }

   else

     {

     GetFileServerID(timeServer,&hostID);

     SetCurrentFileServerID(hostID);

     GetFileServerDateAndTime(serverTime);

     SetCurrentFileServerID(0);

     SetFileServerDateAndTime(serverTime[0],serverTime[1],serverTime[2],

                              serverTime[3],serverTime[4],serverTime[5]);

     LogoutFromFileServer(hostID);

     t=time(NULL);

     printf("Time synchronized, %s",ctime(&t));

     }

   delay(updateInterval*ONE_MINUTE);

   } while (TRUE);

}

