/* definitions for standard programs */



#include <stdlib.h>

#include <conio.h>

#include <stdio.h>

#include <errno.h>

#include <string.h>

#include <ctype.h>

#include <ctype.h>

#include <process.h>



#define MAX_H 80

#define MAX_V 24

#define PLANT 0x0b2a

#define NOPLANT 0x0b20

#define FENCE 0x0b23



typedef WORD FIELD [MAX_V][MAX_H];

FIELD f0,f1,*g0,*g1,*tmp;



/* calculate sprite data using game of live algorithm */



int neighbours(int row,int col)

{

int h,v,n=0;

for (v=row-1;v<=row+1;v++)

  for (h=col-1;h<=col+1;h++)

    n+=(*g0)[v][h]==PLANT;

return n-((*g0)[row][col]==PLANT);

}



void calcNextGeneration(void)

{

int row,col;



for (row=1;row<MAX_V-1;row++)

  {

  ThreadSwitch();

  for (col=1;col<MAX_H-1;col++)

    {

    switch (neighbours(row,col)) {

      case 2: (*g1)[row][col]=(*g0)[row][col]; break;

      case 3: (*g1)[row][col]=PLANT; break;

      default: (*g1)[row][col]=NOPLANT; break;

      }

    }

  }

tmp=g0;

g0=g1;

g1=tmp;

}



void seedField(void)

{

int row,col;

g0=f0; g1=f1;



for (row=0;row<MAX_V;row++)

  {

  ThreadSwitch();

  for (col=0;col<MAX_H;col++)

    if (row==0 || row==(MAX_V-1) || col==0 || col==(MAX_H-1))

      (*g0)[row][col]=NOPLANT;

    else

      (*g0)[row][col]=(rand() % 4) ? NOPLANT : PLANT;

   }

}



void main(int argc, char *argv[])

{

seedField();

do {

   CopyToScreenMemory(MAX_V,MAX_H,(BYTE *)g0,0,1);

   calcNextGeneration();

   delay(500);

   } while (!kbhit());

}

