#include <conio.h>

#include <stdio.h>

#include <errno.h>

#include <string.h>

#include <ctype.h>

#ifdef __TURBOC__

  #include <stdlib.h>

  #define BYTE unsigned char

  #define TRUE 1

#endif



extern unassemble(long,int);



long memAddress=0,dumpLen=0x80;



/* dump memory area */



void dumpMem(void)

{

char *p1,*p2;

BYTE *pb;

int i,j;

if (p1=strtok(NULL," \n\t\r"))

  {

  memAddress=strtoul(p1,NULL,16)&0xfffffff0;

  p2=strtok(NULL," \n\t\r");

  if (p2!=NULL)

    dumpLen=min(strtoul(p2,NULL,16),0x100);

  }

for (i=0;i<=dumpLen/16;i++,memAddress+=16)

  {

  printf("%08lx: ",memAddress);

  pb=(BYTE *)memAddress;

  for (j=0;j<16;j++,pb++)

    printf("%02x ",*pb);

  printf(" | ");

  pb=(BYTE *)memAddress;

  for (j=0;j<16;j++,pb++)

    if (*pb>31)

      putchar(*pb);

    else

      putchar('.');

  printf("\n");

  }

}



/* unassemble memory */



void listMem(void)

{

char *p1,*p2;

BYTE *pb;

int i,instr=0x10;

if (p1=strtok(NULL," \n\t\r"))

  {

  memAddress=strtoul(p1,NULL,16);

  p2=strtok(NULL," \n\t\r");

  if (p2!=NULL)

    instr=min(strtoul(p2,NULL,16),10);

  }

for (i=0;i<instr;i++)

  memAddress=unassemble(memAddress,0);

}



char wait4xkey(void)

{

char c;

do {

   c=toupper(getch());

   } while (strchr("\012\015 0123456789ABCDEF",c)==NULL);

return(c);

}



/* modify memory */



void enterMem(void)

{

char *p1,*p2,c,h[3];

BYTE *pb;

int i,j;

if (p1=strtok(NULL," \n\t\r"))

  {

  memAddress=strtoul(p1,NULL,16);

  p2=strtok(NULL," \n\t\r");

  }

else

  {

  printf("Syntax: ENTER startaddress [hexdata]\n");

  return;

  }

if (p2==NULL) /* interactive mode */

  {

  printf("%08lx: ",memAddress);

  pb=(BYTE *)memAddress;

  do {

     printf("%02x.",*pb);

     c=wait4xkey();

     if (c<31)

       break;

     if (c==' ')

       {

       printf("    ");

       pb++;

       }

     else

       {

       putchar(c);

       h[0]=c;

       h[1]=0;

       c=wait4xkey();

       if (c>' ')

         {

         putchar(c);

         h[1]=c;

         h[2]=0;

         do {

            c=wait4xkey();

            } while (c>' ');

         if (h[1])

           printf("  ");

         else

           printf("   ");

         }

       /* else */

       *pb++=(BYTE)strtoul(h,NULL,16);

         if (c<' ')

           break;

         else

           printf("   ");

       }

     if (((long)pb % 8)==0)

       {

       memAddress=((memAddress & 0xfffffff8)+8);

       printf("\n%08lx: ",memAddress);

       }

     } while(TRUE);

   printf("\n");

  }



}



void main(int argc,char *argv[])

{

int cC,n;

char command[128],*c;



do

  {

  *command=0;

  printf("-> ");

  fgets(command,sizeof(command),stdin);

  if (*command)

    {

    strupr(command);

    c=strtok(command," \n\t\r");

    if (!strncmp(c,"QUIT",strlen(c)))

      return;

    if (!strncmp(c,"DUMP",strlen(c)))

      dumpMem();

    if (!strncmp(c,"ENTER",strlen(c)))

      enterMem();

    if (!strncmp(c,"LIST",strlen(c)))

      listMem();

    if (!strncmp(c,"HELP",strlen(c)))

      printf("Supported commands are Dump Enter Help List Quit ?\n");

    if (!strncmp(c,"?",strlen(c)))

    #ifdef __TURBOC__

      printf("main: %08p\n",main);

    #else

      printf("main: %08lx\n",main);

    #endif

    }

  } while(TRUE);

}

