/* definitions for standard programs */

/* NDS Hook function */



#include <stdlib.h>

#include <conio.h>

#include <stdio.h>

#include <errno.h>

#include <string.h>

#include <ctype.h>

#include <conio.h>

#include <time.h>

#include <process.h>

#include <advanced.h>

#include <nwmisc.h>

#include <nwconn.h>

#include <nwsemaph.h>



long eventHandleCreateObject=NULL;   // handle for RegisterForEvent

long eventHandleRenameObject=NULL;   // handle for RegisterForEvent

long eventHandleDeleteObject=NULL;   // handle for RegisterForEvent

long eventHandleChangeValue=NULL;   // handle for RegisterForEvent

LONG semaV=NULL,semaC=NULL,semaR=NULL,semaD=NULL;

int run=1;



struct EventDSObject theDSObjC,theDSObjR,theDSObjD;



char *Word2ByteStr(WORD *ws)

{

static char s[257];

int i;



for (i=0;i<257;i++)

  if ((s[i]=ws[i])==0) break;

return s;

}



void cleanup()

{

if (eventHandleCreateObject)

  UnregisterForEvent(eventHandleCreateObject);

if (eventHandleRenameObject)

  UnregisterForEvent(eventHandleRenameObject);

if (eventHandleDeleteObject)

  UnregisterForEvent(eventHandleDeleteObject);

if (eventHandleChangeValue)

  UnregisterForEvent(eventHandleChangeValue);

run=0;

//SignalLocalSemaphore(semaC);

//SignalLocalSemaphore(semaR);

//SignalLocalSemaphore(semaD);

SignalLocalSemaphore(semaV);

delay(1000);

if (semaC)

  CloseLocalSemaphore(semaC);

if (semaV)

  CloseLocalSemaphore(semaV);

if (semaR)

  CloseLocalSemaphore(semaR);

if (semaD)

  CloseLocalSemaphore(semaD);

}



void reportCreate(void *p)

{

struct EventBinderyObject *bObj;

struct EventDSObject *dsObj;



while (1) {

WaitOnLocalSemaphore(semaC);

if (!run)

  return;

bObj=(struct EventBinderyObject *)&theDSObjC;

dsObj=(struct EventDSObject *)&theDSObjC;



printf("Create: ");

if (bObj->EventObjectType==EventBinderySignature) // Bindery object

  {

  printf("Bindery object %08lX (type=%04X)\n",bObj->ObjectID,bObj->ObjectType);

  }

else // DS object

  printf("NDS object '%s' %08lX (event type=%04X).\n",

  Word2ByteStr(dsObj->objName),LongSwap(dsObj->objID),dsObj->EventType);

}

}



void reportDelete(void *p)

{

struct EventBinderyObject *bObj;

struct EventDSObject *dsObj;



while (1) {

WaitOnLocalSemaphore(semaD);

if (!run)

  return;

bObj=(struct EventBinderyObject *)&theDSObjD;

dsObj=(struct EventDSObject *)&theDSObjD;



printf("Delete: ");

if (bObj->EventObjectType==EventBinderySignature) // Bindery object

  {

  printf("Bindery object %08lX (type=%04X)\n",bObj->ObjectID,bObj->ObjectType);

  }

else // DS object

  printf("NDS object '%s' %08lX (event type=%04X).\n",

  Word2ByteStr(dsObj->objName),LongSwap(dsObj->objID),dsObj->EventType);

}

}



void reportRename(void *p)

{

struct EventBinderyObject *bObj;

struct EventDSObject *dsObj;



while (1) {

WaitOnLocalSemaphore(semaR);

if (!run)

  return;



bObj=(struct EventBinderyObject *)&theDSObjR;

dsObj=(struct EventDSObject *)&theDSObjR;



cprintf("Rename: ");

if (bObj->EventObjectType==EventBinderySignature) // Bindery object

  {

  cprintf("Bindery object %08lX (type=%04X)\n",bObj->ObjectID,bObj->ObjectType);

  }

else // DS object

  cprintf("NDS object '%s' %08lX (event type=%04X).\n",

  Word2ByteStr(dsObj->objName),LongSwap(dsObj->objID),dsObj->EventType);

}

}



void reportValue(void *p)

{

struct EventBinderyObject *bObj;

struct EventDSObject *dsObj;



while (1) {

WaitOnLocalSemaphore(semaV);

if (!run)

  return;



bObj=(struct EventBinderyObject *)&theDSObjR;

dsObj=(struct EventDSObject *)&theDSObjR;



cprintf("Value: ");

if (bObj->EventObjectType==EventBinderySignature) // Bindery object

  {

  cprintf("Bindery object %08lX (type=%04X)\n",bObj->ObjectID,bObj->ObjectType);

  }

else // DS object

  cprintf("NDS object '%s' %08lX (event type=%04X).\n",

  Word2ByteStr(dsObj->objName),LongSwap(dsObj->objID),dsObj->EventType);

}

}



void eventHandlerCreate(LONG p)

{

memcpy(&theDSObjC,p,sizeof(theDSObjC));

SignalLocalSemaphore(semaC);

}



void eventHandlerChange(LONG p)

{

memcpy(&theDSObjC,p,sizeof(theDSObjC));

SignalLocalSemaphore(semaV);

}



void eventHandlerDelete(LONG p)

{

memcpy(&theDSObjD,p,sizeof(theDSObjD));

SignalLocalSemaphore(semaD);

}



void eventHandlerRename(LONG p)

{

memcpy(&theDSObjR,p,sizeof(theDSObjR));

SignalLocalSemaphore(semaR);

}



void main(int argc, char *argv[])

{

// eventHandleCreateObject=RegisterForEvent(EVENT_CREATE_OBJECT,eventHandlerCreate,NULL);

// eventHandleRenameObject=RegisterForEvent(EVENT_RENAME_OBJECT,eventHandlerRename,NULL);

// eventHandleDeleteObject=RegisterForEvent(EVENT_DELETE_OBJECT,eventHandlerDelete,NULL);

eventHandleChangeValue=RegisterForEvent(EVENT_VALUE_CHANGE,eventHandlerChange,NULL);



atexit ( cleanup );



if (/*eventHandleCreateObject==NULL || eventHandleDeleteObject==NULL ||

  eventHandleRenameObject==NULL ||*/ eventHandleChangeValue==NULL)

  {

  cleanup();

  return;

  }



//semaC=OpenLocalSemaphore(0l);

semaV=OpenLocalSemaphore(0l);

//semaR=OpenLocalSemaphore(0l);

//semaD=OpenLocalSemaphore(0l);



//BeginThread(reportCreate,NULL,4096,NULL);

//BeginThread(reportRename,NULL,4096,NULL);

//BeginThread(reportDelete,NULL,4096,NULL);

BeginThread(reportValue,NULL,4096,NULL);



ExitThread(TSR_THREAD,0);

}

