/* definitions for standard programs */



#include <stdlib.h>

#include <conio.h>

#include <stdio.h>

#include <errno.h>

#include <string.h>

#include <ctype.h>

#include <conio.h>

#include <time.h>

#include <process.h>

#include <advanced.h>



#include <globals.h>

#include <savers.h>



#define DELAY_TIME   200

#define ONE_SECOND   1000

#define ONE_MINUTE   60*ONE_SECOND

#define FIFE_SECONDS 5*ONE_SECOND



int saving=0,saveCount=0;

long eventHandle=NULL;   // handle for RegisterForEvent

char *myname;



void keyPressEventHandler(LONG p)

{

saving=saveCount=0;

}



/* screen saving routine */



void doSave(SCREEN_SAVER *saver)

{

int myScreen;



myScreen=CreateScreen("PH Screen Saver Screen",AUTO_DESTROY_SCREEN | POP_UP_SCREEN);

if (myScreen==NULL)

  return;

SetCurrentScreen(myScreen);

HideInputCursor();

saving=1;

(saver->ScreenSaver)(saver->par1,saver->par2,saver->par3);

if (myScreen)

  DropPopUpScreen(myScreen);

}



void cleanup()

{

if (eventHandle)

  UnregisterForEvent(eventHandle);

}





void usage()

   {

   int i;

      ConsolePrintf ( "Usage %s { ? | [-t<timeout>] [-s<savertype>] [-r]}\n", myname );

      ConsolePrintf ( " -r: use random saver types every time saver gets active.\n");

      ConsolePrintf ( " -t: timeout in s until saver gets active\n");

      ConsolePrintf ( " -s: Choos fixed saver type. Available saver types:\n");

      for (i=0;i<MAX_SAVERS;i++)

        ConsolePrintf(" %d: %s\n",i,savers[i].description);

      ConsolePrintf ( " Default timeout = 60 s.\n");

      ConsolePrintf ( " Default savertype=0.\n");

      exit ( 0 );

   }





int rand2(int last,int maxval)

{

int v;

do {

   v=rand()%maxval;

   } while (v==last);

return v;

}



main ( int argc, char *argv [] )

{

   int   i,timeout=60,saverType=0,run=0,useRandom=0;



   myname=argv[0];



   if ( argc>1 )

     {

     if (argv[1][0]=='?')

       usage();

     else

       for (i=1;i<argc;i++)

         if (argv[i][0]=='-')

           switch (argv[i][1]) {

             case 't' : timeout=atoi(&argv[i][2]); break;

             case 's' : saverType=min(atoi(&argv[i][2]),MAX_SAVERS-1); break;

             case 'r' : useRandom=1; break;

             }

     }



   if (timeout==0)

     timeout=60;

   if (useRandom)

     ConsolePrintf("Using any screen saver with timeout of %d s.\n",timeout);

     else

       ConsolePrintf("Using screen saver '%s' with timeout of %d s.\n",

       savers[saverType].description,timeout);



   eventHandle=RegisterForEvent(EVENT_KEY_WAS_PRESSED,keyPressEventHandler,NULL);

   if (eventHandle==NULL)

     return;

   AtUnload ( cleanup );

   run=1;

   do

   {

      delay(ONE_SECOND);

      saveCount++;

      if (saveCount>timeout)

        {

        doSave(&savers[useRandom ? saverType=rand2(saverType,MAX_SAVERS) : saverType]);

        saveCount=0;

        }

   } while ( run );

}

