/* definitions for standard programs */



#include <stdlib.h>

#include <conio.h>

#include <stdio.h>

#include <errno.h>

#include <string.h>

#include <ctype.h>

#include <nwenvrn.h>

#include <process.h>



typedef void (*tmp)(void);



/* down fileserver and restart machine */



//

//  The following function will 'type' the string passed on the system

//  console.  After it reaches the NULL, it sends a carriage return.

//



int     NWSystem(char *command)

{

        LONG    OldScrID = GetCurrentScreen();

        LONG    NewScrID = CreateScreen("System Console",0);

if (!CheckNetWareVersion(4,0,0,0,0))

  return system(command);   // if running on Netware 4.x "system()" is available

        //

        //  Set the current screen to the system console

        //

        if( OldScrID != NewScrID) SetCurrentScreen(NewScrID);

        //

        //  Send the entire string to the console.  Do a ThreadSwitch

        //  after each character to allow the console to clear its buffer.

        //

        for( ; *command; command++ ) ungetch(*command), ThreadSwitch();

        //

        //  Send the CR

        //

        ungetch('\r');

        //

        //  Restore the screen

        //

        if( OldScrID != NewScrID) SetCurrentScreen(OldScrID);



        return 0;

}



void usage(char *msg)

{

  ConsolePrintf("%sUsage: LOAD RESTART restart-time (given in HH:MM)\n",msg);

  ConsolePrintf("  Example:   LOAD RESTART 23:59  restarts server at 23:59\n");

}



void main(int argc, char *argv[])

{

int rhour=-1,rmin=-1;

char *p;

BYTE fsdate[7];



if (argc==1)

  usage("Missing restart time\n\r");

else

  {

  rhour=atoi(p=strtok(argv[1],":"));

  if (p)

    rmin=atoi(strtok(NULL,""));

  if (rhour>=0 && rhour<24 && rmin>=0 && rmin<59)

    {

    ConsolePrintf("\rRestart will be at %02d:%02d\n",rhour,rmin);

    do {

       delay(5000);

       GetFileServerDateAndTime(fsdate);

       if (fsdate[3]==rhour && fsdate[4]==rmin)

         {

         NWSystem("remove dos");

         DownFileServer(TRUE);

         NWSystem("EXIT");

         }

       } while (TRUE);

    }

  else

    usage("Invalid restart time\n");

  }

}

