/* definitions for standard programs */



#include <stdlib.h>

#include <conio.h>

#include <stdio.h>

#include <errno.h>

#include <string.h>

#include <ctype.h>

#include <process.h>

#include <nwbindry.h>

#include <nwconn.h>



#define DELAY delay(2000)

#define NOLOGIN 0x00

#define LOGIN   0xff



int port=0,nologin=NOLOGIN,login=LOGIN;



int loggedIn(char *who)

{

WORD connList[10],numConn;

if (GetObjectConnectionNumbers(who,OT_USER,&numConn,connList,10))

  return(0);

return(numConn);

}



void printerout(int portval)

{

outp(port,portval);

outp(port+2,inp(port+2) & 0xfe);  /* STROBE = 0 */

delay(1);

outp(port+2,inp(port+2) | 1);     /* STROBE = 1 */

}



void cleanup(void)

{

if (!port)

  return;

printerout(login);

}



void usage(char *prog,char *msg)

  {

  printf("%s\n",msg);

  printf("Verwende load %s portadresse username [notloginwert [loginwert]]\n",prog);

  printf("  portadresse  : Adresse fr LPT1 oder ? fr automatische Erkennung\n");

  printf("  username     : Benutzername, der berwacht werden soll\n");

  printf("  notloginwert : Wert, der ausgegeben wird, wenn Benutzer nicht angemeldet\n");

  printf("                 Voreinstellung %02X\n",NOLOGIN);

  printf("  loginwert    : Wert, der ausgegeben wird, wenn Benutzer angemeldet\n");

  printf("                 Voreinstellung %02X\n",LOGIN);

  printf("                 Dieser Wert wird auch ausgegeben, wenn der NLM entladen wird\n");

  }



void main(int argc, char *argv[])

{

BYTE portval=1;

char *user;



if (argc<3)

  {

  usage(argv[0],"Zu wenig Parameter");

  return;

  }



if (!strcmp(argv[1],"?")) /* auto detect */

  port=*(WORD *)0x408l;

else

  port=(int) strtoul(argv[1],NULL,16);

user=strupr(argv[2]);



if (argc>3)

  nologin=(int) strtoul(argv[3],NULL,16);

if (argc>4)

  login=(int) strtoul(argv[4],NULL,16);



if (port==0)

  {

  usage(argv[0],"Ungltige Portadresse oder nicht im BIOS eingetragen\n");

  return;

  }



AtUnload(cleanup);

printf("Watchdog fr Benutzer %s: Wert fr nicht angemeldet/angemeldet: %02X %02X\n",user,nologin,login);

printf("Portadresse: %04X\n",port);



do {

   if (loggedIn(user))

     {

     printf("\r%s angemeldet      ",user);

     if (portval==nologin)

       printerout(portval=login);

     }

   else

     {

     printf("\r%s nicht angemeldet",user);

       printerout(portval=nologin);

     }

   DELAY;

   } while (1);

cleanup();

}

