/* definitions for standard programs */



#include <stdlib.h>

#include <conio.h>

#include <stdio.h>

#include <errno.h>

#include <string.h>

#include <ctype.h>

#include <conio.h>

#include <time.h>

#include <process.h>

#include <advanced.h>

#include <nwmisc.h>

#include <nwconn.h>



#define AL_UNC 0x10a0011



long eventHandleNetwareAlert=NULL;   // handle for RegisterForEvent



void cleanup()

{

if (eventHandleNetwareAlert)

  UnregisterForEvent(eventHandleNetwareAlert);

}



void alertHandler(LONG p)

{

struct EventNetwareAlertStruct *a=p;

LONG *arg=a->alertParameters;



if (a->alertSeverity)

  if (a->alertId != AL_UNC)

  {

  printf("\nAlert ID=%lx,severity=%ld\n",a->alertId,a->alertSeverity);

  switch (a->alertParmCount) {

    case 0: printf("%s\n",a->alertControlString); break;

    case 1: printf(a->alertControlString,arg[0]); break;

    case 2: printf(a->alertControlString,arg[0],arg[1]); break;

    case 3: printf(a->alertControlString,arg[0],arg[1],arg[2]); break;

    case 4: printf(a->alertControlString,arg[0],arg[1],arg[2],arg[3]); break;

    default: printf("%d,'%s'\n",a->alertParmCount,a->alertControlString);

    }

  }

}



void main(int argc, char *argv[])

{

eventHandleNetwareAlert=RegisterForEvent(EVENT_NETWARE_ALERT,alertHandler,NULL);



if  (eventHandleNetwareAlert==NULL)

  {

  cleanup();

  return;

  }

AtUnload ( cleanup );

ExitThread(TSR_THREAD,0);

}

